program PCFG;

uses dos, crt, dose50, pump, OLM;


var  Contrast   : Byte;
     Setup      : Byte;
     Bright     : Byte;
     LCD        : Byte;
     setok      : Boolean;
     show       : Boolean;
     German     : Boolean;
     ShowHelp   : Boolean;

     ZeichenTab : Array[0..7,0..7] of Byte;
     LogoTab    : Array[0..3,0..19] of Byte;

const Display1  : Array[0..3] of String =
                    ('PUMPconfigurator',
                     '(c) Ulrich Prinz',
                     'Firmware 1201 ',
                     'needed. Have Fun');


Procedure Flash_spec_char;
var i : Byte;
begin
  for i:=0 to 63 do begin
    Writeln( 'Programming Special Characters: ', i);
    gotoxy( 1, wherey-1);
    Seteeprom(i   ,ZeichenTab[i DIV 8,i MOD 8]); {Sonderzeichen}
  end;
end;


Procedure Flas_Logo;
var i : Byte;
begin
  for i:=0 to 79 do begin
    Writeln( 'Programming Screen            : ', i);
    gotoxy( 1, wherey-1);
    Seteeprom(i+64,LogoTab[i DIV 20,i MOD 20]);  {Logo}
  end;
end;



Procedure Readout;
begin
  contrast := GetEEPROM( P_contrast);
  setup    := GetEEPROM( P_setup);
  lcd      := GetEEPROM( P_lcd);
end;


Procedure Show_Readout;
var s : string;
begin
  ClrScr;
  ScrWInClr( $1f, 1, 1, 80, 19);
  GotoXY( 1, 3);
  ScrWinTxtZ( $70, 1, 1, 80, 'PUMP Configurator');
  ScrWInTxt( $70, 80-length( Version)-2, 1, ' '+Version);
  ScrWInTxtZ( $1F, 1, 2, 80, '(c) by Ulrich Prinz    ---    http://go.to/uprinz    ---    uprinz@ginko.de');

  ReadOut;
  Lines( $1e, 1, 80, 3, 1);
  case German of
    true  : begin
              ScrWinTxt( $1F, 3,  4, 'SystemCFG  : 0x'+ hex( setup)+' = '+bitstr(setup)+'b');
              ScrWinTxt( $1F, 3,  5, '                    ٳ1: 8 Tasten am PUMP');
              ScrWinTxt( $1F, 3,  6, '                          0: 4x4 Matrix oder 32 Tasten-Matrix');
              ScrWinTxt( $1F, 3,  7, '  1: normales LCDٳ   ');
              ScrWinTxt( $1F, 3,  8, '  0: 4x40 LCD           1: Drehgeber arbeitet als Encoder ');
              ScrWinTxt( $1F, 3,  9, '                            0: Drehgeber erzeugt Tastendrcke');
              ScrWinTxt( $1F, 3, 10, '         reserviert   ');
              ScrWinTxt( $1F, 3, 11, '                         1: 4x4 Matrix Tastatur');
              ScrWinTxt( $1F, 3, 12, '                              0: 32 Tasten-Matrix');
              ScrWinTxt( $1E, 3, 17, 'PCFG ist nur fr Firmware 1201 oder neuer.    PCFG -h gibt eine Hilfe aus...');
            end;
    false : begin
              ScrWinTxt( $1F, 3,  4, 'SystemCFG  : 0x'+ hex( setup)+' = '+bitstr(setup)+'b');
              ScrWinTxt( $1F, 3,  5, '                    ٳ1: 8 Button Keyboard');
              ScrWinTxt( $1F, 3,  6, '                          0: 4x4 Matrix or 32 Key Matrix');
              ScrWinTxt( $1F, 3,  7, '    1: normal LCDٳ   ');
              ScrWinTxt( $1F, 3,  8, '    0: 4x40 LCD         1: normal rotary switch behaviour');
              ScrWinTxt( $1F, 3,  9, '                            0: encoder increment will give key press');
              ScrWinTxt( $1F, 3, 10, '         reserved   ');
              ScrWinTxt( $1F, 3, 11, '                         1: 4x4 Matrix Keyboard');
              ScrWinTxt( $1F, 3, 12, '                              0: 32 Key Matrix');
              ScrWinTxt( $1E, 3, 17, 'Note: PCFG requires Firmware 1201 or newer       Call PCFG -h to get help...');
            end;
  end;
  Lines( $1e, 1, 80, 13, 1);
  case lcd of
    $ff : s := 'init only';
    $00 : s := 'do nothing';
    $01 : s := ' init & Logo 2x16';
    $02 : s := ' init & Logo 2x20';
    $03 : s := ' init & Logo 4x16';
    $04 : s := ' init & Logo 4x20';
    $FE : s := ' init & Logo AUTO';
    else  s:= 'ILLEGAL!';
  end;
  ScrWinTxt( $1f, 3, 14, 'LCD Type   : 0x'+ hex( lcd)+' : '+s);
  ScrWinTxt( $1f, 3, 15, 'Contrast   : '+ ldby( contrast));
  Lines( $1e, 1, 80, 16, 1);
end;


Procedure HELP;
begin;
  ClrScr;
  ScrWinClr( $1f, 1, 1, 80, 25);
  ScrWinTxtZ( $70, 1, 1, 80, 'PUMP Configurator');
  ScrWInTxt( $70, 80-length( Version)-2, 1, ' '+Version);
  ScrWInTxtZ( $1F, 1, 2, 80, '(c) by Ulrich Prinz    ---    http://go.to/uprinz    ---    uprinz@ginko.de');

  Lines( $1F, 1, 80, 3, 2);

  case german of
    false : begin
              MenuLine( $1F, $1e,  4, 'Usage : PCFG [option:parametr] [option:parameter]...');
              MenuLine( $1F, $1e,  5, 'Options:');
              MenuLine( $1F, $1e,  6, 'none       will give you an overview over the actual settings');
              MenuLine( $1F, $1e,  7, '~-h~         will show you this helpscreen');
              MenuLine( $1F, $1e,  8, '~-k~xxx      sets the contrast while xxx is a decimal within 0..255');
              MenuLine( $1F, $1e,  9, '~-t~ssss     sets the type of LCD you use: ~init~ : just initialize');
              MenuLine( $1F, $1e, 10, '                ~2x16~, ~2x20~, ~4x16~, ~4x20~, ~4x40~, ~none~ or ~auto~');
              MenuLine( $1F, $1e, 11, '~-d:[k|e]~   sets encoder behaviour as ~k~ey or ~e~ncoder');
              MenuLine( $1F, $1e, 12, '~-m:[m|s|e]~ sets keyboard to ~s~tandard (8 key), ~m~atrix (16 key) or ~e~xtended');
              MenuLine( $1F, $1e, 13, '                extended = 32 keys with 74HC183 as decoder on keyboard');
              MenuLine( $1F, $1e, 14, '~-v~         display this screen ~after~ settings are made to verify them');
              MenuLine( $1F, $1e, 15, '~-r~         resets all settings to standard');
              MenuLine( $1F, $1e, 16, '~-p:yyy~     set LPT address in hex 378, 278, 3bc');
              MenuLine( $1F, $1e, 17, 'If an error occures a text and a beep will occure.');
              MenuLine( $1F, $1e, 19, 'Logo flashing is not yet implemented but it will be in future.');
              MenuLine( $1F, $1e, 20, 'I thought it''s not that important cause every player has its own logo with it.');
            end;
    true  : begin
              MenuLine( $1F, $1e,  4, 'Kommando: PCFG [option:parametr] [option:parameter]...');
              MenuLine( $1F, $1e,  5, 'Optionen:');
              MenuLine( $1F, $1e,  6, 'none       gibt die aktuellen Einstellungen auf dem Bildschirm aus');
              MenuLine( $1F, $1e,  7, '~-h~         zeigt diese Hilfe');
              MenuLine( $1F, $1e,  8, '~-k~xxx      setzt den Kontrast wobei xxx einen Wert zwischen 0..255 haben mu');
              MenuLine( $1F, $1e,  9, '~-t~ssss     stellt den Typ des LCDs ein: ~init~ : nur initialisieren');
              MenuLine( $1F, $1e, 10, '                ~2x16~, ~2x20~, ~4x16~, ~4x20~, ~4x40~, ~none~ oder ~auto~');
              MenuLine( $1F, $1e, 11, '~-d:[k|e]~   Verhalten des Drehgebers als Taste (~k~ey) oder ~E~ncoder');
              MenuLine( $1F, $1e, 12, '~-m:[m|s|e]~ Keyboardtyp : ~S~tandart (8 Tasten), ~M~atrix (16 Tasten) oder');
              MenuLine( $1F, $1e, 13, '                ~E~xtended (32 Tasten durch einen 74HC183 auf dem Tastenboard');
              MenuLine( $1F, $1e, 14, '~-v~         Verify : Stelle alle nderungen auf dem Bildschirm dar');
              MenuLine( $1F, $1e, 15, '~-r~         Setzte den PUMP auf Standart zurck');
              MenuLine( $1F, $1e, 16, '~-p:yyy~     Whle LPT-Port Adresse 378, 278, 3bc)');
              MenuLine( $1F, $1e, 17, 'Ein Piepen und eine zugehrige Fehlermeldung erscheint, wenn Parameter falsch');
              MenuLine( $1F, $1e, 18, 'sind. Der Schalter ~-e~ schaltet PCFG auf englisch um.');
              MenuLine( $1F, $1e, 19, 'Logos knnen mit PCFG noch nicht ''geflasht'' werden, kommt aber vielleicht noch.');
              MenuLine( $1F, $1e, 20, 'Ich hielt es nicht fr so wichtig, da jede Playersoft ihr Logo mitbringt.');
            end;
  end;
  Lines( $1F, 1, 80, 21, 2);
end;


Procedure GetLPT( var lpt : Word);
var e, v, i : integer;
    s       : string;
begin
  for i := 1 to ParamCount do begin

    s := Upstr( ParamStr( 1));
    if pos( '-P:', s) <> 0 then begin
      Delete( s, 1, 3);
      s := '$'+s;
      val( s, v, e);
      if e = 0 then begin
        lpt := v;

        writeln( 'Setting LPT to Address: '+lhex( lpt)); end
      else writeln( 'Illegal Port for LPT:'+s);
    end;
  end;
end;




Procedure Commandline;
var i : Byte;
    s : string;

  Procedure SetKontrast( var s : string);
  var i, e : integer;
  begin
    delete( s, 1, 2);
    val(s, i, e);
    if (e <> 0) or (i<0) or (i>255) then Writeln( 'ERROR: Cannot interprete Value for -k! Use PCFG -h for help')
    else begin
      Writeln( 'Setting Contrast to: ',i);
      Seteeprom( P_contrast, i);
      setok := true;
    end;
  end;


  Procedure SetLCDType( var s : string);
  var good    : boolean;
      LCD4x40 : Byte;

  begin
    delete( s, 1, 3);

    good := false;

    if s='NONE' then begin LCD := $00; LCD4x40 := $ff; good := true; end;
    if s='INIT' then begin LCD := $FF; LCD4x40 := $ff; good := true; end;
    if s='2X16' then begin LCD := $01; LCD4x40 := $ff; good := true; end;
    if s='2X20' then begin LCD := $02; LCD4x40 := $ff; good := true; end;
    if s='4X16' then begin LCD := $03; LCD4x40 := $ff; good := true; end;
    if s='4X20' then begin LCD := $04; LCD4x40 := $ff; good := true; end;
    if s='AUTO' then begin LCD := $FE; LCD4x40 := $ff; good := true; end;
    if s='4X40' then begin LCD := $02; LCD4x40 := $7f; good := true end;

    if good then begin
      SetPUMPlcd( LCD);
      setup := (setup and $7F) or LCD4x40;
      SetPUMPcfg( setup);
      setok := true;
      end
    else begin
      writeln( 'ERROR: Could not set lcd type : '+s+'!  Use PCFG -h for help');
      lbeep;
    end;
  end;


  Procedure SetEncoder( var s : string);
  var setok : Boolean;
  begin
    case s[3] of
      'K' : begin setup := setup and $FD; SetEEPROM( P_setup, setup); end;
      'E' : begin setup := setup or  $02; SetEEPROM( P_setup, setup); end;
      else  begin Writeln('ERROR: Could not interprete encoder setting!  Use PCFG -h for help'); lbeep; end;
    end;
  end;


  Procedure SetMatrix( var s : string);
  begin
    case s[3] of
      'M' : begin setup := (setup and $FE) or $04; SetEEPROM( P_setup, setup); end;
      'S' : begin setup := setup or  $05; SetEEPROM( P_setup, setup); end;
      'E' : begin setup := (setup and $FA); SetEEPROM( P_setup, setup); end;
      else  begin Writeln( 'ERROR: Could not interprete encoder setting!  Use PCFG -h for help'); lbeep; end;
    end;
  end;



  Procedure SwitchPort( var s : string);
  begin
    Delete( s, 1, pos( ':', s));
    if length( s) = 1 then begin
      case s[1] of
        '1' : lpt := $378;
        '2' : lpt := $278;
        '3' : lpt := $3bc;
        else  Writeln( 'Wrong value for lpt-port');
      end;
    end
    else Writeln( 'Wrong value for lpt-port');
  end;




begin
  If ParamCount = 0 then Show := true
    else begin
    For i := 1 to Paramcount do begin
      s := UpStr( ParamStr(i));
      if s[1]='-' then begin
        case upcase(s[2]) of
          'H',
          '?' : ShowHelp := true;
          'K' : SetKontrast( s);
          'T' : SetLCDType( s);
          'D' : SetEncoder( s);
          'M' : SetMatrix( s);
          'R' : begin SetEEPROM( P_setup, $FF); SetEEPROM( P_LCD, $FF); end;
          'V' : Show := true;
          'E' : German := false;
          'O' : OnlineMode;
          'P' : begin end;
          else  Writeln( 'Illegal Paramter in Commandline! Use PCFG -h for help');
        end;
      end;
    end;
  end;
end;



var ver : byte;

begin
  setok := false;
  Show := false;
  German := true;

  ClrScr;
{  ResetPUMP;}
  GetLPT( lpt);

  gotoxy( 1, 20);
  dosvar.showexitlogo := false;
  Readout;

  Commandline;
  if setok then begin delay(1000); Write(1,$04); end;{ Reset}
  if Show then Show_Readout;
  if ShowHelp then Help;
  gotoxy( 1, 23);
{  GetDispDim;}
  {move( Display1, LCDbuf, 4*256);
  UpdateDisp;}
end.
